/**
 * @beta
 * Create a set of message names with a namespace.
 */
export const createPrefixesConstants = (namespace, messages, channelId) => {
    const result = {};
    messages.forEach(message => {
        result[message] = channelId
            ? `${namespace}:${channelId}:${message}`
            : `${namespace}:${message}`;
    });
    return result;
};
/**
 * @beta
 * Message names for post messages.
 */
export const getPostMessageNames = (channelId) => createPrefixesConstants('octostar:post-messages', ['get_api'], channelId);
/**
 * @beta
 * API names.
 */
export const apiNames = createPrefixesConstants('octostar:api-names', [
    'desktop',
    'ontology',
    'context',
    'extras',
    'remoteApp',
    'savedSearch',
], undefined);
// test
// const v = messages.get_api;
//# sourceMappingURL=constants.js.map