/* eslint-disable no-restricted-syntax */
export const makeProxy = (obj, excludeKeys = []) => {
    const proxyObj = {};
    // Get prototype methods
    const proto = Object.getPrototypeOf(obj);
    if (proto) {
        for (const key of Object.getOwnPropertyNames(proto)) {
            if (key !== 'constructor' &&
                typeof proto[key] === 'function' &&
                !excludeKeys.includes(key)) {
                proxyObj[key] = proto[key].bind(obj);
            }
        }
    }
    return proxyObj;
};
//# sourceMappingURL=Proxy.js.map