import { v5 as uuidv5 } from 'uuid';
const NAMESPACE = '9a5e7f16-23c0-49c0-8339-b441d8a84373';
export const getOrCreateUsersPrivateWorkspaceRecord = async (desktop, ontology) => {
    const user = await desktop.whoami();
    const entity_id = uuidv5(user.username, NAMESPACE);
    const not_in_database = `This entity is not in the database ${Date.now()}`;
    const workspace = await ontology.getEntity({
        entity_type: 'os_workspace',
        entity_id,
        entity_label: not_in_database,
    });
    if (workspace.entity_label === not_in_database) {
        return desktop
            .createWorkspace(`${user.username} Workspace`, {
            id: entity_id,
        })
            .then((ws) => {
            desktop.setActiveWorkspace(ws.entity_id);
            return ws;
        });
    }
    return desktop.setActiveWorkspace(workspace.entity_id).then(() => workspace);
};
//# sourceMappingURL=userWorkspace.js.map