import { Properties } from 'csstype';
/**
 * @beta
 * Type representing a React component.
 */
export interface RefObject<T> {
    readonly current: T | null;
}
/**
 * @beta
 * Type representing a React ref callback.
 */
export type RefCallback<T> = {
    bivarianceHack(instance: T | null): void;
}['bivarianceHack'];
/**
 * @beta
 * Type representing a React ref.
 */
export type ReactRef<T> = RefCallback<T> | RefObject<T> | null;
/**
 * @beta
 * Type representing a React CSS properties object.
 */
export type ReactCssProperties = Properties<string | number>;
/**
 * Represents a React node.
 * @beta
 */
export type ReactNode = any;
//# sourceMappingURL=react-types.d.ts.map